let rec transformation i j p =
  for k = 0 to (j-i)/2 do
      let tmp = p.(i+k) in
        p.(i+k) <- p.(j-k);
        p.(j-k) <- tmp;
    done;
    p.((Array.length p) - 1 ) <- p.(0);;
    
(* ATTENTION : cette dernire ligne est peut-tre la cause des bugs de "crossing" (suppression du dernier lement si on fournit un chemin sans rptition du premier lment  la fin *)

let gain g p i j n = 
     g.(p.((i-1+n) mod n)).(p.(j)) +. g.(p.(i)).(p.((j+1) mod n))
-. ( g.(p.((i-1+n) mod n)).(p.(i)) +. g.(p.(j)).(p.((j+1) mod n)) );;

(*******************************************************************************************************)
let rec ancien_two_opt g p = 
  let n = Array.length g and meilleurs = Array.of_list p and changement = ref false in
    for i = 0 to n-1 do
      for j = i+1 to n-1 do
        if not (i=0 && j=n-1) && gain g meilleurs i j n < 0.0 then 
          (
            
            transformation i j meilleurs;
            changement := true;
          )  
      done;
    done;
  if !changement then 
    ancien_two_opt g (Array.to_list meilleurs)
  else
    Array.to_list meilleurs;;

(*****************************************************************************************************)

let gain2 g p j n = 
     g.(p.(n-1)).(p.(j)) +. g.(p.(0)).(p.(j+1))
-. ( g.(p.(n-1)).(p.(0)) +. g.(p.(j)).(p.(j+1)) );;
    
let rec two_opt g p = 
  let n = Array.length g and actuelle = ref (List.tl p) and meilleure_trans = ref (0,0) and meilleur_gain = ref 0.0 in
    for i = 0 to n-2 do
     let tmp = Array.of_list !actuelle in
      for j = 1 to n-2 do
        let gain_1 = gain2 g tmp j n in
          if gain_1 < !meilleur_gain then 
            (
              meilleur_gain := gain_1;
              meilleure_trans := tmp.(0), tmp.(j);
            )
      done;
      actuelle := (List.tl !actuelle) @ [List.hd !actuelle];
     done;
    
 match !meilleure_trans with
   0,0 -> p
 | i,j -> let bidon = (Trajet.connect_with_first j (Trajet.rotate_until i (List.tl p))) in
            two_opt g (bidon @ [List.hd bidon]);;

(*************************************************************************************************)

(* meileurs : a = 30 b = 5 *)


let recuit_simule_ g p it =
  let a = 45.0 and b = 4.250 in
  let n = Array.length g and meilleurs = Array.of_list p in
    
    for j = 2 to n-2 do
     let e = gain g meilleurs 0 j n in
       if ((Random.float 1.0) <= exp ( -. e *. (a +. it *. b))) then 
         transformation 0 j meilleurs;
    done;
    
    for i = 1 to n-1 do
     for j = i+1 to n-1 do
       let e = gain g meilleurs i j n in
          if ((Random.float 1.0) <= exp ( -. e *. (a +. it *. b))) then 
            transformation i j meilleurs;
     done;
    done;
  Array.to_list meilleurs;;  
  
  
let rec recuit_simule g p it = 
  match (recuit_simule_ g p it), it with
    x, n when n > 50.0 -> x
  | x, _               -> 
(*    Printf.printf "%f  %f \n" it (Trajet.longueur g x);
    flush(stdout);*)
    recuit_simule g (x) (it +. 1.0);;