(********* quelques fonctions (pour la plupart inutiles) sur les permutations *****)

let rec intervalle = function
  0 -> [0]
| n -> (intervalle (n-1))@[n]

let swap a i j =
 let tmp = a.(i) in
   a.(i) <- a.(j);
   a.(j) <- tmp;;

let identite n = Array.of_list (intervalle n);;

let cycle n cyc =
  let c = Array.of_list cyc in 
   let res = identite n and n2 = Array.length c in
     for i = 0 to n2 - 1 do 
       res.(c.(i)) <- c.((i + 1) mod n2)
     done;
     res

let compose f g = 
  let n = Array.length f in
    let res = Array.make n 0 in
      for i = 0 to n-1 do
	res.(i) <- f.(g.(i))
      done;
      res;;

exception Trouve of int;;     

let rec parcours_cycle f i = function
  x::suite when x = f.(i) -> f.(i) <- i;
			     x::suite
| l -> let j = f.(i) in
	       f.(i) <- i;
	       parcours_cycle f j (l @ [j]);;

let rec decompose f = 
  let n = Array.length f
  in
  try 
    for i = 0 to (n-1) do
      if f.(i) != i then raise (Trouve i)
    done;
    [] 
  with
    Trouve i ->   let tmp = parcours_cycle f f.(i) [i;f.(i)] 
		  in
		  f.(i) <- i;
		  tmp :: (decompose f);;

let reciproque f = 
  let n = Array.length f 
  in let res = Array.make n 0 in
  for i = 0 to n - 1 do
    res.(f.(i)) <- i
  done;
  res;;

(***************** gnration de permutations (trajets) alatoires en O(n) ***********)

let aleatoire g = 
  let n = Array.length g in
  let possible = Array.make n 0 and res = Array.make n 0 and taille = ref n in

  for i = 0 to n-1 do
    possible.(i) <- i
  done;  

  for i = 0 to n-1 do
    let j = Random.int !taille in
      res.(i) <- possible.(j);
      swap possible j (!taille - 1);
      decr taille;
  done;
  let tmp = Array.to_list res and deb = res.(n-1) in
    deb :: tmp
