let gain g p i j n =
  g.(p.((i-1+n) mod n)).(p.(j)) +. g.(p.(i)).(p.((j+1) mod n))
  -. (g.(p.((i-1+n) mod n)).(p.(i)) +. g.(p.(j)).(p.((j+1) mod n)) );;

let rec optimumize = function
  [] -> invalid_arg "liste vide"
| x::[] -> x
| (x,c)::(_,y)::_ when c < y -> x, c
| _::suite -> optimumize suite;;
     
     
let rec two_opt g p =
  let n = Array.length g and meilleurs = Array.of_list p and changement = ref false and stock = ref [] in
    
    for j = 1 to (n-2) do
      let ga = gain g meilleurs 0 j n in 
      if ga < 0.0 then stock := ((0,j),ga)::(!stock);
    done;
    
    for i = 1 to n-1 do
      for j = i+1 to n-1 do
        let ga = gain g meilleurs i j n in 
	  if ga < 0.0 then stock := ((i,j),ga)::(!stock);
      done;
    done;
    
   if !stock != [] then 
     (
       
       match optimumize !stock with
         ((i,j), cout) -> TwoOpt.transformation i j meilleurs;
                          two_opt g (Array.to_list meilleurs)
     )  
    else
      Array.to_list meilleurs;;